// Auto-generated from armory.html.
// DO NOT EDIT.

library armory_html;

import 'dart:html' as autogenerated;
import 'dart:svg' as autogenerated_svg;
import 'package:web_ui/web_ui.dart' as autogenerated;
import 'package:web_ui/observe/observable.dart' as __observe;
import 'weapon.html.dart';
import 'armor.html.dart';
import "dart:html";
import 'package:web_ui/watcher.dart' as watcher;
import '../dataloader.dart';
import '../datacontainer.dart';
import '../localization.dart';
import '../quality.dart';
import '../subcategory.dart';
import '../maincategory.dart';
import '../weapon.dart';
import '../armor.dart';
import '../IFilterableItem.dart';
import '../ISortableItem.dart';


// Original code


main() {
 
}

void OnLoadPackageClicked(MouseEvent e)
{
  var button = e.currentTarget as ButtonElement;
  var packageToLoad = button.id;
  StartLoadingPackage(packageToLoad);
}

String BaseUrl = "http://community-hub.cliffhanger-productions.com:8090/jao/";

DataLoader Loader;

void StartLoadingPackage(String package)
{
  Loader = new DataLoader(BaseUrl, package);
  Loader.DataLoaded.stream.listen(OnDataLoaded);
  
  Loader.Start();
}

void OnDataLoaded(String data)
{
  switch(data)
  {
    case DataLoader.LocalizedText:
      Loca = Loader.Loca;
      break;
      
    case DataLoader.Weapons:
      CurrentWeapons = Loader.WeaponData.toList();
      CurrentWeapons.sort(ItemLevelSort);
      break;
      
    case DataLoader.SubCategories:
      CurrentSubCategories = Loader.SubCategoryData.toList();
      break;
      
    case DataLoader.Armors:
      CurrentArmors = Loader.ArmorData.toList();
      CurrentArmors.sort(ItemLevelSort);
      break;
  }
  watcher.dispatch();
}

void OnMainCategorySelected(MouseEvent event)
{  
  var li = event.currentTarget as LIElement;
  SelectMainCategory(li.id);
}

void SelectMainCategory(String id)
{
  switch(id)
  {
    case MainCategory.Weapon:
      CurrentDisplayingItems = CurrentWeapons;
      break;
    case MainCategory.Armor:
      CurrentDisplayingItems = CurrentArmors;
      break;
  }
  CurrentMainCategory = id;
  SelectedSubCategory = CurrentSubCategories.firstWhere((s) => s.MainCategory == CurrentMainCategory).id;
}

List<Weapon> CurrentWeapons;
Localization Loca;
List<SubCategory> CurrentSubCategories;
List<Armor> CurrentArmors;

String NameFilter = "";
var qualityLevels = Quality.Levels;
String SelectedQuality = "";
String SelectedSubCategory = "2";
String CurrentMainCategory = MainCategory.Weapon;
List<IFilterableItem> CurrentDisplayingItems;

bool ApplyFilter(IFilterableItem item)
{
  return Loca.Get(item.Name).toLowerCase().contains(NameFilter.toLowerCase()) 
      && (SelectedQuality == "" || item.QualityLevel == SelectedQuality)
      && (SelectedSubCategory == "" || item.ItemCategory == SelectedSubCategory);
}

bool IsSelectedCategory(SubCategory category)
{
  return category.MainCategory == CurrentMainCategory;
}

int ItemLevelSort(ISortableItem a, ISortableItem b)
{
  return a.Level - b.Level;
}
// Additional generated code
void init_autogenerated() {
  var _root = autogenerated.document.body;
  final __html0 = new autogenerated.Element.html('<li class="button"></li>'), __html1 = new autogenerated.Element.html('<li class="button"></li>'), __html10 = new autogenerated.Element.html('<div is="jao-weapon"></div>'), __html11 = new autogenerated.Element.tag('template'), __html12 = new autogenerated.Element.html('<div is="jao-armor"></div>'), __html2 = new autogenerated.Element.html('<input type="hidden">'), __html3 = new autogenerated.Element.tag('template'), __html4 = new autogenerated.ButtonElement(), __html5 = new autogenerated.Element.html('<div class="item-filter">\n        Filter: <input type="text" placeholder="Search for name here">\n        Quality Level: \n        <select>\n            <option value="" selected="">All</option>\n            <option style="display:none"></option>\n        </select>\n        Category:\n        <select>\n            <option value="">All</option>\n            <option style="display:none"></option>\n        </select>\n      </div>'), __html6 = new autogenerated.Element.html('<option template="" repeat="quality in Quality.Levels.values"></option>'), __html7 = new autogenerated.Element.html('<option template="" repeat="category in CurrentSubCategories.where(IsSelectedCategory)"></option>'), __html8 = new autogenerated.Element.tag('template'), __html9 = new autogenerated.Element.tag('template');
  var __e25, __e4, __e9;
  var __t = new autogenerated.Template(_root);
  __e4 = _root.nodes[1].nodes[1].nodes[3];
  __t.conditional(__e4, () => CurrentWeapons != null && CurrentArmors != null, (__t) {
    var __e1, __e3;
    __e1 = __html0.clone(true);
    var __binding0 = __t.contentBind(() => CurrentWeapons.length, false);
    __e1.nodes.addAll([new autogenerated.Text('\n             Weapons ('),
        __binding0,
        new autogenerated.Text(')\n          ')]);
    __t.listen(__e1.onClick, ($event) { OnMainCategorySelected($event); });
    __t.oneWayBind(() => MainCategory.Weapon, (e) { if (__e1.id != e) __e1.id = e; }, false, false);
    __e3 = __html1.clone(true);
    var __binding2 = __t.contentBind(() => CurrentArmors.length, false);
    __e3.nodes.addAll([new autogenerated.Text('\n              Armors ('),
        __binding2,
        new autogenerated.Text(')\n          ')]);
    __t.listen(__e3.onClick, ($event) { OnMainCategorySelected($event); });
    __t.oneWayBind(() => MainCategory.Armor, (e) { if (__e3.id != e) __e3.id = e; }, false, false);
  __t.addAll([new autogenerated.Text('\n          '),
      __e1,
      new autogenerated.Text('\n          '),
      __e3,
      new autogenerated.Text('\n        ')]);
  });

  __e9 = _root.nodes[3];
  __t.conditional(__e9, () => CurrentWeapons == null || Loca == null || CurrentSubCategories == null || CurrentArmors == null || Loader.ArmorOpticsData == null, (__t) {
    var __e5, __e8;
    __e5 = __html2.clone(true);
    __t.listen(__e5.onInput, ($event) { BaseUrl = __e5.value; });
    __t.oneWayBind(() => BaseUrl, (e) { if (__e5.value != e) __e5.value = e; }, false, false);
    __e8 = __html3.clone(true);
    __t.loop(__e8, () => DataLoader.AvailablePackages, ($list, $index, __t) {
      var package = $list[$index];
      var __e7;
      __e7 = __html4.clone(true);
      var __binding6 = __t.contentBind(() => package, false);
      __e7.nodes.add(__binding6);
      __t.listen(__e7.onClick, ($event) { OnLoadPackageClicked($event); });
      __t.oneWayBind(() => package, (e) { if (__e7.id != e) __e7.id = e; }, false, false);
    __t.addAll([new autogenerated.Text('\n          '),
        __e7,
        new autogenerated.Text('\n      ')]);
    });
  __t.addAll([new autogenerated.Text('\n      Choose Package\n      '),
      __e5,
      new autogenerated.Text('\n      '),
      __e8,
      new autogenerated.Text('\n    ')]);
  });

  __e25 = _root.nodes[5];
  __t.conditional(__e25, () => CurrentDisplayingItems != null && CurrentSubCategories != null && Loca != null, (__t) {
    var __e10, __e13, __e14, __e17, __e18, __e19, __e24;
    __e19 = __html5.clone(true);
    __e10 = __e19.nodes[1];
    __t.listen(__e10.onInput, ($event) { NameFilter = __e10.value; });
    __t.oneWayBind(() => NameFilter, (e) { if (__e10.value != e) __e10.value = e; }, false, false);
    __e14 = __e19.nodes[3];
    __e13 = __e14.nodes[3];
    __t.loop(__e13, () => Quality.Levels.values, ($list, $index, __t) {
      var quality = $list[$index];
      var __e12;
      __e12 = __html6.clone(true);
      var __binding11 = __t.contentBind(() => Loca.Get(quality.id), false);
      __e12.nodes.add(__binding11);
      __t.oneWayBind(() => SelectedQuality == quality.id, (e) { if (__e12.selected != e) __e12.selected = e; }, false, false);
      __t.oneWayBind(() => quality.id, (e) { if (__e12.value != e) __e12.value = e; }, false, false);
    __t.add(__e12);
    });
    __t.listen(__e14.onChange, ($event) { SelectedQuality = __e14.value; });
    __t.oneWayBind(() => SelectedQuality, (e) { if (__e14.value != e) __e14.value = e; }, false, false);
    __e18 = __e19.nodes[5];
    __e17 = __e18.nodes[3];
    __t.loop(__e17, () => CurrentSubCategories.where(IsSelectedCategory), ($list, $index, __t) {
      var category = $list[$index];
      var __e16;
      __e16 = __html7.clone(true);
      var __binding15 = __t.contentBind(() => Loca.Get(category.Name), false);
      __e16.nodes.add(__binding15);
      __t.oneWayBind(() => category.id, (e) { if (__e16.value != e) __e16.value = e; }, false, false);
    __t.add(__e16);
    });
    __t.listen(__e18.onChange, ($event) { SelectedSubCategory = __e18.value; });
    __t.oneWayBind(() => SelectedSubCategory, (e) { if (__e18.value != e) __e18.value = e; }, false, false);
    __e24 = __html8.clone(true);
    __t.loop(__e24, () => CurrentDisplayingItems.where(ApplyFilter), ($list, $index, __t) {
      var item = $list[$index];
      var __e21, __e23;
      __e21 = __html9.clone(true);
      __t.conditional(__e21, () => item is Weapon, (__t) {
        var __e20;
        __e20 = __html10.clone(true);
        __t.oneWayBind(() => Loader.CurrentPackage, (e) { if (__e20.xtag.currentpackage != e) __e20.xtag.currentpackage = e; }, false, false);
        __t.oneWayBind(() => item as Weapon, (e) { if (__e20.xtag.instance != e) __e20.xtag.instance = e; }, false, false);
        __t.oneWayBind(() => Loca, (e) { if (__e20.xtag.loca != e) __e20.xtag.loca = e; }, false, false);
        __t.component(new JaoWeapon()..host = __e20);
      __t.addAll([new autogenerated.Text('\n              '),
          __e20,
          new autogenerated.Text('\n           ')]);
      });

      __e23 = __html11.clone(true);
      __t.conditional(__e23, () => item is Armor, (__t) {
        var __e22;
        __e22 = __html12.clone(true);
        __t.oneWayBind(() => Loader.CurrentPackage, (e) { if (__e22.xtag.currentpackage != e) __e22.xtag.currentpackage = e; }, false, false);
        __t.oneWayBind(() => item as Armor, (e) { if (__e22.xtag.instance != e) __e22.xtag.instance = e; }, false, false);
        __t.oneWayBind(() => Loca, (e) { if (__e22.xtag.loca != e) __e22.xtag.loca = e; }, false, false);
        __t.component(new JaoArmor()..host = __e22);
      __t.addAll([new autogenerated.Text('\n              '),
          __e22,
          new autogenerated.Text('\n           ')]);
      });

    __t.addAll([new autogenerated.Text('\n           '),
        __e21,
        new autogenerated.Text('\n           \n           '),
        __e23,
        new autogenerated.Text('\n      ')]);
    });
  __t.addAll([new autogenerated.Text('\n      '),
      __e19,
      new autogenerated.Text('\n      \n      '),
      __e24,
      new autogenerated.Text('\n    ')]);
  });

  __t.create();
  __t.insert();
}

//@ sourceMappingURL=armory.dart.map